# N body simulation OpenMP

#Ref: https://stackoverflow.com/questions/49384301/make-clean-failed-in-windows
ifeq ($(OS),Windows_NT)
	RM = del /Q /F
	CP = copy /Y
        EXP = set

	ifdef ComSpec
		SHELL := $(ComSpec)
	endif

	ifdef COMSPEC
		SHELL := $(COMSPEC)
	endif
else
	RM = rm -rf
	CP = cp -f
	EXP = export
endif


#Ref: https://makefiletutorial.com/
CC=gcc

DEPS=    
SRC=  poisson.c  
OBJ=  poisson.o  
TAREXE=  poisson.exe


all: clean compile run

.PHONY: compile
compile: $(OBJ)
		$(CC) -Wall -g -fopenmp -o $(TAREXE) $(OBJ) 

%.o: %.c $(DEPS) $(SRC)
		$(CC) -Wall -g -fopenmp -o $@  -c $<  

#Ref: https://www.gnu.org/software/make/manual/html_node/Phony-Targets.html
.PHONY: run
run: $(TAREXE) 
	 $(EXP) OMP_NUM_THREADS=8  &&  $(TAREXE)   

.PHONY: clean  
clean: 
	-$(RM) *.o
	-$(RM) $(TAREXE)
	@echo "clean complete"


